package com.jpmorrsn.javaFBP;
import java.util.*;


/**
 * @author paul.morrison
 *
 * Detects deadlock, based on network inactivity for at least 5 secs,
 * but not more than 10 secs.
 */
public class DeadlockDetect extends Thread {
	
	     int interval;
	     Network thisnet;
	     
         DeadlockDetect(int intvl, Network net) {
            interval = intvl;  // Interval in seconds
            thisnet = net;    // mother net
         }
 
         public void run() {
         	 Integer i = new Integer(interval * 1000);
             while (true) {
             	try {sleep(i.longValue());}
             	catch (InterruptedException e) {break;};
             	if (!thisnet.active) {
             		try {sleep(i.longValue());}
             	    catch (InterruptedException e) {break;};
             	    if (!thisnet.active) {
             	    	System.out.println("Network has deadlocked");
             	    	Iterator all = (thisnet.components.values()).iterator();                 
             			while (all.hasNext()) {
             				Component comp = (Component)(all.next());
             				//String[] desc = {"not started", "active", "dormant",
             				//		"suspended on receive", "suspended on send",
             					//	"terminated"};
             			//	int k = comp.status.getValue();
             				System.out.println("-- "+ comp.getName()+ " " + 
             						comp.status.toString());  //corr. Jan. 31, 2008
             				}
             			
             	    	
             	    	thisnet.interruptAll(); 
                        thisnet.waitForAll();
             	        break;
             	        }
             		
             	   }
             	else
             	    thisnet.active = false;   
             	
             }
             
         }
        

}
