package com.jpmorrsn.javaFBP;




/** This is used in a network definition when a port is not connected
*/

final class NullConnection implements InputPort {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";

	static NullConnection singleton = new NullConnection();


	private NullConnection() {}
	/** Return capacity of 0
	*/

	public int capacity() {
		return 0;
		}
	public void close() {}
	public int count() {
		return 0;
		}
	

	public Component getReceiver() {  //added for subnet support 
		return null;
		}	
	public boolean isClosed() {
		return true;
		}
	public Packet receive() {
		return null;
		}
	public void setReceiver(Component newReceiver) {  // added for subnet support 
		
		}
	public void setType(Class type) {}
}
