package com.jpmorrsn.javaFBP;

/** Look after input to subnet -  added for subnet support.  This version of
 * SubIn supports Substream Sensitivity
 */
 
public class SubInSS extends Component {
	static final String copyright = 
		"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
		"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
		"based on the Everything Development Company's Artistic License.  A document describing " +
		"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
		"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";
	
	   InputPort inport, nameport;
	   OutputPort outport;
	   


	   	protected void execute() throws Throwable {
	   		Packet np = nameport.receive();
			if (np == null) {
				return;
				}
			String pname = (String) np.getContent();
			np.drop();
			
		    inport = (InputPort) (mother.getInports()).get(pname);
		    Component oldReceiver = inport.getReceiver();
		    inport.setReceiver(this);
			
	   		Packet p;
	   		while ((p = inport.receive()) != null) {
	   		 	p.setOwner(this);
	   		    if (p.getType() == Packet.OPEN){
	   		    	p.drop();
	   		    	network.GenTraceLine(this.getName() + " open bracket detected");
	   		    }
	   		    else if (p.getType() == Packet.CLOSE) {
	   		    	p.drop();
	   		    	network.GenTraceLine(this.getName() + " close bracket detected");
	   		    	break;
	   		    }
	   		 	else 
	   			  if (!(outport.send(p))) {
			    	  p.drop();
			    	  }
	   		}
	   		
	   		// inport.close();   // ????
	   		inport.setReceiver(oldReceiver);
	   		
	   		inport = null;
	   		// outport.close();
	   		}
	   	
	   		protected Object[] introspect() {
	   			 		return new Object[] {
	   			   		"handles one input stream for subnet",
	   			   		"NAME", "input", String.class,
	   						"name of higher level input port",
	   					"OUT", "output", Object.class,
	   						"output to output port"};
	   			   		}
	   	protected void openPorts() {

	   	 nameport = openInput("NAME");	
	     outport = openOutput("OUT");
	   		}
	   }

