package com.jpmorrsn.javaFBP;


/** Look after (synchronous) output/input from/to subnet.
 * This component sends a packet out to the (external) output port, and then 
 * immediately does a receive from the corresponding (external) input port. 
 */
 
public class SubOI extends Component {
	static final String copyright = 
		"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
		"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
		"based on the Everything Development Company's Artistic License.  A document describing " +
		"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
		"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";

	   InputPort inport, nameport, extinport;
	   OutputPort outport, extoutport;


	   	protected void execute() throws Throwable {
	   		Packet np = nameport.receive();
			if (np == null) {
				return;
				}
			String pname = (String) np.getContent();
			np.drop();
			
			int i = pname.indexOf(":");
			String oname = pname.substring(0,i);
			String iname = pname.substring(i + 1);
		    extoutport = (OutputPort) (mother.getOutports()).get(oname);
		    extoutport.setSender(this);	
		    
		    extinport = (InputPort) (mother.getInports()).get(iname);
		    Component oldReceiver = extinport.getReceiver();
		    extinport.setReceiver(this);
		    
	   		Packet p;
	   		while ((p = inport.receive()) != null) {
	   			if (!(extoutport.send(p))) {
			    	p.drop();
			    	}
	   			p = extinport.receive();
		   		p.setOwner(this);
		   		if (!(outport.send(p))) {
				   p.drop();
				   }
	   		}
	   		extinport.setReceiver(oldReceiver);
	   		extinport = null;
	   		
	//   	extoutport.close();
	   		extoutport = null;
	   		}
	   	protected Object[] introspect() {
	   		return new Object[] {
	   		"handles one output/input stream for subnet",
	   		"NAME", "input", String.class,
				"contains names of higher level output and input port, separated by :",
			"IN", "input", Object.class,
			     "input (from subnet) to external port",
			"OUT", "output", Object.class,
				"output from external port (into subnet)"};
	   		}
	   	protected void openPorts() {

	   	 nameport = openInput("NAME");	
	     
	     inport = openInput("IN");
	     outport = openOutput("OUT");
	   		}
	   }

