package com.jpmorrsn.javaFBP;


/** Look after output from subnet - added for subnet support 
 */
 
public class SubOut extends Component {
	static final String copyright = 
		"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
		"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
		"based on the Everything Development Company's Artistic License.  A document describing " +
		"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
		"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";

	   InputPort inport, nameport;
	   OutputPort outport;


	   	protected void execute() throws Throwable {
	   		Packet np = nameport.receive();
			if (np == null) {
				return;
				}
			String pname = (String) np.getContent();
			np.drop();
			
		    outport = (OutputPort) (mother.getOutports()).get(pname);
		    outport.setSender(this);	
	   		Packet p;
	   		while ((p = inport.receive()) != null) {
	   			if (!(outport.send(p))) {
			    	p.drop();
			    	}
	   		}
	   		
	//   		outport.close();
	   		outport = null;
	   		}
	   	protected Object[] introspect() {
	   		return new Object[] {
	   		"handles one output stream for subnet",
	   		"NAME", "input", String.class,
				"name of higher level output port",
			"IN", "input", Object.class,
				"input (from subnet) to external port"};
	   		}
	   	protected void openPorts() {

	   	 nameport = openInput("NAME");	
	     inport = openInput("IN");
	   		}
	   }

