package com.jpmorrsn.javaFBP.test.networks;

import com.jpmorrsn.javaFBP.*;
import com.jpmorrsn.javaFBP.verbs.*;
import java.io.FileReader;



/** This network is similar to the one called Deadlock, but has been modified slightly 
so that it doesn't deadlock */

public class NoDeadlock extends Network {  

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";


	
	protected void define() throws Throwable {
		component("MONITOR", Monitor.class);
		connect(component("Read", ReadText.class),
			port("OUT"),
			component("Splitter1", Splitter1.class),
			port("IN"));
		initialize(new FileReader("com\\jpmorrsn\\javaFBP\\test\\data\\myXML3.txt"),
			component("Read"),
			port("SOURCE"));
		
		connect(component("Splitter1"),
			port("OUT", 0),
			component("Concatenate", Concatenate.class),
			port("IN", 0));
		
		connect(component("Concatenate"),
			port("OUT"),
			component("Discard", Discard.class),
			port("IN"));

		connect(component("Splitter1"),
			port("OUT", 1),
			component("Concatenate"),
			port("IN", 1));
		
		connect(component("Splitter1"),
			port("OUT", 2),
			component("Concatenate"),
			port("IN", 2));
		}
	public static void main(String[] argv) {
		new NoDeadlock().go();
		}
}
