package com.jpmorrsn.javaFBP.test.networks;

import com.jpmorrsn.javaFBP.*;
import com.jpmorrsn.javaFBP.verbs.*;
import java.io.FileReader;
import java.io.OutputStreamWriter;


/** This network tests an InputPort array where some slots are Connections and one 
 * is an InitializationConnection */

public class TestMixedInput extends Network {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";


	
	protected void define() throws Throwable {
		component("MONITOR", Monitor.class);
		connect(component("Read", ReadText.class),
			port("OUT"),
			component("Splitter1", Splitter1.class),
			port("IN"));
		initialize(new FileReader("com\\jpmorrsn\\javaFBP\\test\\data\\myXML3.txt"),
			component("Read"),
			port("SOURCE"));
		
		connect(component("Splitter1"),
			port("OUT", 0),
			component("Concatenate", Concatenate.class),
			port("IN", 1));
		
		connect(component("Concatenate"),
			port("OUT"),
			component("Write", WriteText.class),
			port("IN"));

		connect(component("Splitter1"),
			port("OUT", 1),
			component("Concatenate"),
			port("IN", 2));
			
		initialize(new String("ABCDEF"),
			component("Concatenate"),
			port("IN",0));	
			
		initialize(new OutputStreamWriter(System.out),
			component("Write"),
			port("DESTINATION"));	
		
		
		}
	public static void main(String[] argv) {
		new TestMixedInput().go();
		}
}
