package com.jpmorrsn.javaFBP.test.networks;

import com.jpmorrsn.javaFBP.*;
import com.jpmorrsn.javaFBP.verbs.*;
import java.io.FileReader;
import java.io.OutputStreamWriter;



public class TryReplicate extends Network {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";


	
	protected void define() throws Throwable {
		connect(component("Read", ReadText.class),
			port("OUT"),
			component("Replicate", ReplString.class),
			port("IN"));
		initialize(new FileReader("com\\jpmorrsn\\javaFBP\\test\\data\\myXML3.txt"),
			component("Read"),
			port("SOURCE"));
		
		connect(component("Replicate"),
			port("OUT[0]"),
			component("Write1", WriteText.class),
			port("IN"));

		connect(component("Replicate"),
			port("OUT[1]"),
			component("Write2", WriteText.class),
			port("IN"));
		
		connect(component("Replicate"),
			port("OUT[2]"),
			component("Write3", WriteText.class),
			port("IN"));
		initialize(new OutputStreamWriter(System.out),
				component("Write1"),
				port("DESTINATION"));
		initialize(new OutputStreamWriter(System.out),
				component("Write2"),
				port("DESTINATION"));
		initialize(new OutputStreamWriter(System.out),
				component("Write3"),
				port("DESTINATION"));
		}
	public static void main(String[] argv) {
		new TryReplicate().go();
		}
}
