package com.jpmorrsn.javaFBP.test.networks;  // Change as required 
import com.jpmorrsn.javaFBP.*; 
import com.jpmorrsn.javaFBP.verbs.*; 
import com.jpmorrsn.javaFBP.test.parms.*; 
import java.io.*; 

/** This is really the front end of an Update app - instead of routing the merged stream 
 * to a processing component, we just display it.
 * 
 * @author HP_Administrator
 *
 */ 
public class Update extends Network { 
	protected void define() throws Throwable { 
component("@Read@ Master (1)", ReadFile.class); 
component("@Read@ Details (2)", ReadFile.class); 
component("@@Collate (3)", Collate.class); 
component("@@Display (4)", WriteText.class); 
connect(component("@Read@ Master (1)"), port("OUT"), component("@@Collate (3)"), port("IN[0]")); 
connect(component("@Read@ Details (2)"), port("OUT"), component("@@Collate (3)"), port("IN[1]")); 
connect(component("@@Collate (3)"), port("OUT"), component("@@Display (4)"), port("IN")); 
initialize(new FileReader("com\\jpmorrsn\\javaFBP\\test\\data\\mfile"), component("@Read@ Master (1)"), port("SOURCE")); 
initialize(new FileReader("com\\jpmorrsn\\javaFBP\\test\\data\\dfile"), component("@Read@ Details (2)"), port("SOURCE")); 
initialize(new OutputStreamWriter(System.out), component("@@Display (4)"), port("DESTINATION")); 

initialize(new CollateParm(new int[] {3,2,5}), component("@@Collate (3)"), port("CTLFIELDS")); 

 } 
public static void main(String[] argv) { 
	new Update().go(); 
} 

 }