package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;
import java.util.HashMap;



/** Component to check for duplicate names in GEDCOM files
 */



public class CheckForDupNames extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";



	InputPort inport;
	
	protected void execute() throws Throwable {

		
		Packet p;
		
		HashMap<String,String> map = new HashMap<String,String>();
		String str;
		String key;
		

		while ((p = inport.receive()) != null) {
			str = (String) p.getContent();
			if (str.substring(0,6).equals("1 NAME")) { 
				key = str.substring(7).trim();
				if (map.containsKey(key)) 
				   System.out.println("Duplicate name: "+key);
				else
				   map.put(key,"Y"); 
			}
			p.drop();
		}	

	}
	protected Object[] introspect() {
		return new Object[] {
		"checks for duplicate names", 
		"IN", "input", Object.class,
			"input stream",
		    };
		}
	protected void openPorts() {

		inport = openInput("IN");
		inport.setType(String.class);

		

		}
}
