package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;



/** Component to concatenate all packets in the input stream into 
* one long String, which is then sent to the output port.
*/

public class ConcatStr extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";

	

	InputPort inport;
	OutputPort outport;
	
	protected void execute() throws Throwable {
	    
	    String target = "";
	    Packet p;
		while ((p = inport.receive()) != null) {

			String s = (String) p.getContent();
			target = target + s;
			p.drop();
			}
		Packet out = create(target);
		if (!(outport.send(out))) 
			  	out.drop();
			   	
	}
	protected Object[] introspect() {
		return new Object[] {
		"obtains strings from port IN and concatenates them into one" +
		" long string, which is output at end of stream",
		"IN", "input", String.class,
			"input stream",
		"OUT", "output", String.class,
			"output stream"};
		}
	protected void openPorts() {
		
		inport = openInput("IN");
		
		outport= openOutput("OUT");
			
		}
}
