package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;



/** Component to concatenate two or more streams of packets
*/

public class Concatenate extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";

	

	InputPort[] inportArray;
	OutputPort outport;
	
	protected void execute() throws Throwable {
	    
		int no = inportArray.length;
					
	    Packet p;
	    for (int i = 0; i < no; i++) { 
		    while ((p = inportArray[i].receive()) != null) {
 			   if (!(outport.send(p))) 
			    	p.drop();
			   }
		 
		    } 
	}
	protected Object[] introspect() {
		return new Object[] {
		"concatenates input streams at array port IN and sends them to port OUT",
		"IN", "input", Object.class,
			"multiple input streams",
		"OUT", "output", Object.class,
			"output stream"};
		}
	protected void openPorts() {
		
		inportArray = openInputArray("IN");
	//		inport.setType(Object.class);

		outport = openOutput("OUT");
			
		}
}
