package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;


/** Component to discard all incoming packets - mostly used for
* debugging purposes.
*/

public class Discard extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";


	InputPort inport;


	protected void execute() throws Throwable {
		Packet p;
		while ((p = inport.receive()) != null) {
			p.drop();
			}

		}
	protected Object[] introspect() {
		return new Object[] {
		"discards its input",
		"IN", "input", null,
			"packets to discard"};
		}
	protected void openPorts() {
		inport = openInput("IN");
		inport.setType(Object.class);
		}
}
