package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;


/** Component to generate a stream of 'n' packets, where 'n' is
* specified in an InitializationConnection.
*/

public class Generate extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";



	OutputPort outport;

	InputPort count;


	protected void execute() throws Throwable {
		Packet ctp = count.receive();
		if (ctp == null) {
			return;
			}
		Integer cti = (Integer) ctp.getContent();
		int ct = cti.intValue();
		ctp.drop();
		
		for (int i = 0; i < ct; i++) {
			int j = ct - i;
			Integer j2 = new Integer(j);
			String s = j2.toString();
			if (j < 10) s = "0" + s;
			if (j < 100) s = "0" + s;
			s = s + "abc";
			
			Packet p = create(s);
			if (!(outport.send(p))) {
				p.drop();
				return;
				}

			}

		// output.close();
		// terminate();
		}
	protected Object[] introspect() {
		return new Object[] {
		"generates a set of Packets under control of a counter" ,
		"OUT", "output", String.class,
			"lines read",
		"COUNT", "parameter", Integer.class,
			"Count of number of entities to be generated"};
		}
	protected void openPorts() {

		outport = openOutput("OUT");
		outport.setType(String.class);

		count = openInput("COUNT");
		count.setType(Integer.class);

		}
}
