package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;



/** Component to generate packets every 'n' milliseconds, where 'n' is
* specified in an InitializationConnection.
*/


public class Heartbeat extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";



	OutputPort outport;

	InputPort interval;


	protected void execute() throws Throwable {
		// receive interval in milliseconds
		Packet itvl = interval.receive();
		if (itvl == null) {
			return;
			}
		Long itl = (Long) itvl.getContent();
		long it = itl.longValue();
		itvl.drop();
		String s = " ";

		// when the send returns false, this component closes down

		while (true) {
			Packet p = create(s);
			if (!(outport.send(p))) {
				p.drop();
				return;
				}
	        sleep(it);
			}

		}
	protected Object[] introspect() {
		return new Object[] {
		"generates a set of entities under control of a counter" ,
		"OUT", "output", String.class,
			"lines read",
		"COUNT", "parameter", Integer.class,
			"Count of number of entities to be generated"};
		}
	protected void openPorts() {

		outport = openOutput("OUT");
		outport.setType(String.class);

		interval = openInput("INTERVAL");
		interval.setType(Long.class);

		}
}
