package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;
import java.util.Iterator;




/** Component to inspect the status of all components once a second. 
*/

public class Monitor extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";
	
   

   
   public void execute()
   {

	   Iterator all;                  
	
	   String states[] = { "Not Started", "Active", "Dormant", "Susp/Recv", 
		   "Susp/Send", "Terminated"};

	   boolean allTerminated = false; 

		   boolean v = System.getProperty("javaflow.verbose", "false" ).equalsIgnoreCase( "true" );
	   boolean v2 = System.getProperty("javaflow.verbose.out", "false" ).equalsIgnoreCase( "true" );

	   if (!v && !v2)
	       return;
	   
	   while (!allTerminated) {
		   network.GenMonitorLine("Status display ....");
		   allTerminated = true;
		   all = network.enumerateComponents();
	
	       while (all.hasNext()) {               
	           Component c = (Component)(all.next());    
	           if (!c.getName().equals("MONITOR"))  {
	               network.GenMonitorLine("- " + c.getName() + " - " + 
	            		   states[c.getStatus().getValue()]);
	               if (c.getStatus() != StatusValues.TERMINATED)  
	                   allTerminated = false;
	               }
	           }
	       network.GenMonitorLine("...End of display");
	       try {sleep(60000);}  // sleep 60 sec (was 1 sec)
	       catch(InterruptedException e) {};
	       }
	   
	    }
   public Object[] introspect()
   {
		return new Object[] {
		"reads input RMQueue" +
		" and outputs to CacheManager or BE" };
   }   
   /**
   @roseuid 38ECF6380229
   */
   public void openPorts()
   {
	
   }   
}
