package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;

/** Pass a stream of Packets to an output stream.

**/

public class Passthru extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";


	InputPort inport;
	OutputPort outport;

	protected void execute() throws Throwable {

		

	    Packet p;
		while ((p = inport.receive()) != null) {
						
		
			    if (!(outport.send(p))) {
			    	p.drop();
			    	}
		        }
			}
		
	
	protected Object[] introspect() {
		return new Object[] {
		"passes input stream at port IN through to port OUT",
		"IN", "input", Object.class,
			"input stream",
		"OUT", "output", Object.class,
			"output stream"};
		}
	protected void openPorts() {

		inport = openInput("IN");
		inport.setType(Object.class);

		outport = openOutput("OUT");

		}
}
