package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;




/** Component to remove DEAT records with blank dates from GEDCOM files
 */



public class RemoveBlankDeat extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";



	InputPort inport;
	OutputPort outport;

	protected void execute() throws Throwable {

		
		Packet p;
		Packet deat = null;
		
		boolean dropSw = false;
		String str;

		while ((p = inport.receive()) != null) {
			str = (String) p.getContent();
			
			if ((str.substring(0,1)).equals("1")) {
               dropSw = false; 
               System.out.println("dropsw = f");
			   }
              
            if ((str.substring(0,6)).equals("1 DEAT")) {
               dropSw = true; 
               System.out.println("dropsw = t");
               deat = p;
               }
              
            
            if (dropSw && 
                  (str.substring(0,6)).equals("2 DATE")) { 
               System.out.println("2 date found");   	
               if ((str.substring(0,6)).equals(str.trim())) {
               	   deat.drop();  //dropSw left true
               	   System.out.println("dropsw still t");
               }
               	   
               else {
               	   if (!(outport.send(deat))) 
			    	   deat.drop(); 
                   dropSw = false;	
                   System.out.println("dropsw back to f");
                   }
               deat = null;   
               }  
               
            if (deat == null)   
                if (dropSw) 
                    p.drop();
                else 
			        if (!(outport.send(p))) 
			       	    p.drop();
			    	    
			    	
		}	

	}
	protected Object[] introspect() {
		return new Object[] {
		"removes DEAT groups with blank date", 
		"IN", "input", Object.class,
			"input stream",
		"OUT", "output", Object.class,
			"output stream"};
		}
	protected void openPorts() {

		inport = openInput("IN");
		inport.setType(String.class);

		outport = openOutput("OUT");
		outport.setType(String.class);

		}
}
