package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;



/** Replicate a stream of Packets to 'n' output streams, where
*  each Packet points at a String.
* Note: this is a specific variant of the general Replicate verb (q.v.)
**/

public class ReplString extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";


	InputPort inport;
	OutputPort[] outportArray;

	protected void execute() throws Throwable {

		int no = outportArray.length;

	    Packet p;
	    long count = 0;
		while ((p = inport.receive()) != null) {
			++count;
			String o = (String) p.getContent();
			p.drop();

			for (int i = 0; i < no; i++) {
				String o2 = new String(o);
			    Packet p2 = create(o2);
			    if (!(outportArray[i].send(p2))) {
			    	p2.drop();
			    	}
			    
		        }
			}
		network.GenTraceLine( "Repl complete. "+ getName());
	}
	protected Object[] introspect() {
		return new Object[] {
		"replicates input stream at port IN and sends them to array port OUT",
		"IN", "input", Object.class,
			"input stream",
		"OUT", "output", Object.class,
			"multiple output streams"};
		}
	protected void openPorts() {

		inport = openInput("IN");
		inport.setType(Object.class);

		outportArray = openOutputArray("OUT");

		}
}
