package com.jpmorrsn.javaFBP.verbs;

import com.jpmorrsn.javaFBP.*;

/** Sort a stream of Packets to an output stream
**/

public class Sort extends Component {

static final String copyright = 
"Copyright 1999, 2000, 2001, 2002, J. Paul Morrison.  At your option, you may copy, " +
"distribute, or make derivative works under the terms of the Clarified Artistic License, " +
"based on the Everything Development Company's Artistic License.  A document describing " +
"this License may be found at http://www.jpaulmorrison.com/fbp/artistic2.htm. " +
"THERE IS NO WARRANTY; USE THIS PRODUCT AT YOUR OWN RISK.";


	InputPort inport;
	OutputPort outport;

	protected void execute() throws Throwable {

		
	    Packet p;
	    int i = 0, j, k, n;
		Packet[] array = new Packet[9999];
		while ((p = inport.receive()) != null) {
			array[i] = p;
			System.out.println("in: " + p.getContent());
			++i; 
			}
		
		network.GenTraceLine(this.getName() + ": No. of elements:" + i);
		j = 0;
		k = i;
		n = k;  // no. of packets to be sent out
		
		
		
		while (n > 0) {
		  String t = "\uffff";
		  
		  for (i = 0; i < k; i++) {
		    if (array[i] != null) {
		      
			  String s = (String) array[i].getContent();
			  
			  if (s.compareTo(t) < 0) {
			    j = i;
			    t = (String) array[j].getContent();
			    }
		      }	
		    
		  }
		  if (array[j] == null) break;
		  if (!(outport.send(array[j]))) 
				  array[j].drop();
		  array[j] = null;
		  
		  --n;
		  			
	      }
	    
	}
    
	protected Object[] introspect() {
		return new Object[] {
		"sorts input stream arriving at port IN and sends result to port OUT",
		"IN", "input", Object.class,
			"input stream",
		"OUT", "output", Object.class,
			"output stream"};
		}
	protected void openPorts() {

		inport = openInput("IN");
		inport.setType(Packet.class);

		outport = openOutput("OUT");

		}
}
